/* Constants.c
 * $Format: " * Version $ProjectVersion$"$
 * Version 0.27
 * Michael McTernan, mm7323@Bris.ac.uk
 * 25/11/99
 */ 

#ifndef WIN32
  #include <unistd.h>
#endif

#define CONSOLE_WARNINGS

#include <stdio.h> 
#include <stdlib.h> 
#include <string.h> 
#include "Constants.h"

/*CN_RealError*/
/* Display error message and exit.
 */
void CN_RealError(const char *Message,const char *File,int Line)
{
  char charbuf[256];
  fprintf(stderr, "%s: %d: Error: %s",CN_ExtractFileName(File),Line,Message);
  sprintf(charbuf,"%s: %d: Error: %s\n",CN_ExtractFileName(File),Line,Message);
  if(Message[strlen(Message)-1]!='\n')
    fprintf(stderr,"\n");
  perror("Errno");
  exit(0);
}


/*CN_RealWarning*/
/* Print a standard warning message.
 */
void CN_RealWarning(const char *Message,const char *File,int Line)
{
  char charbuf[256];
  sprintf(charbuf,"%s: %d: Warning: %s\n",CN_ExtractFileName(File),Line,Message);
  fprintf(stderr, charbuf);
}


/*ExtractFileName*/
/* Extracts the filename from a string and discards the path
   information
*/
char *CN_ExtractFileName(const char *Path)
{
  char *end = &Path[strlen(Path)];

  while(*end != '\\' && end != Path)
    end--;

  return *end=='\\' ? end+1:end;
}

