/* Constants.h
 * $Format: " * Version $ProjectVersion$"$
 * Version 0.27
 * Michael McTernan, mm7323@Bris.ac.uk
 * 14/11/99
 */ 


#ifndef CONSTANTS_HEADER
#define CONSTANTS_HEADER

/* Things to fix win32 problems */
#ifdef WIN32
  #define gettimeofday(a,b)    {(a)->tv_sec=timeGetTime()/1000;(a)->tv_usec=(timeGetTime()%1000)*1000; }
  #define inline __inline
  #include <wtypes.h>
  typedef enum {false,true} booleantype_t;
  #define boolean booleantype_t
  #define strcasecmp(a,b)  stricmp((a),(b))
  #define strncasecmp(a,b,n) strnicmp((a),(b),(n))
#endif

/* Global types */
#ifndef WIN32
  typedef enum {false,true} boolean;
#endif

/* Constants */
#define MATH_TRIG_ACCURACY    8  /* 1/8th of a degree */
#define MATH_RND_ELEMENTS  1024

/* Debugging options */
#define DEBUG(a)       a

/* Phony Function Prototypes */
#define CN_Error(a)    CN_RealError(a,__FILE__,__LINE__)
#define CN_Warning(a)  CN_RealWarning(a,__FILE__,__LINE__)
#define _min(a,b)      ((a)<(b)?(a):(b))
#define _max(a,b)      ((a)>(b)?(a):(b))

/* Function Prototypes */
void  CN_RealError        (const char *Message,const char *File,int Line);
void  CN_RealWarning      (const char *Message,const char *File,int Line);
char *CN_ExtractFileName  (const char *Path);

#endif

