/* Main.c
 * Michael McTernan, mm7323@Bris.ac.uk
 * 31/05/99
 */ 
 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include "ASELoader.h"

static GLuint DisplayList;
static float Angle[3],Step[3][3];

/* Internal function Prototypes */
static void InitGL();
static void InitWindow(int *ArgC, char **ArgV);
static void Reshape(int Width,int Height);
static void Idle();
static void Display();

/*main*/
int main(int ArgC,char **ArgV)
{
  int t,u;

  InitWindow(&ArgC,ArgV);
  InitGL();

  /* Init some other stuff here */
  DisplayList=ASE_MakeDList("Truck/","Truck.ase");

  for(t=0;t<3;t++) {
    for(u=0;t<3;t++) {
      Angle[t]=0;
      Step[t][u]=((float)rand()/RAND_MAX)*2.0;
    }
  }

  glutMainLoop();
  return 0;
}


/*InitWindow*/
/* Make a window
 */
static void InitWindow(int *ArgC, char **ArgV) {
    
  glutInit                (ArgC,ArgV);
  glutInitDisplayMode     (GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH);
  glutInitWindowSize      (400,400);
  glutCreateWindow        ("ASE Loader Demo");
  glutFullScreen();
  glutReshapeFunc         (Reshape);
  glutIdleFunc            (Idle);
  glutDisplayFunc         (Display);
  glutSetCursor           (GLUT_CURSOR_LEFT_ARROW);

}

/*InitGL*/
/* Set up the GL options
 */
static void InitGL() {
  GLfloat l[]={400,0,400,0};    

  /* Clear both frame buffers to black */
  glClearColor(0.0,0.0,0.5,1.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glutSwapBuffers();
  glClear(GL_COLOR_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);
  glCullFace(GL_BACK);
  glColorMaterial(GL_FRONT,GL_DIFFUSE);
  glEnable(GL_COLOR_MATERIAL);

  glLightfv(GL_LIGHT0,GL_POSITION,l);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  printf("Renderer: %s\n",glGetString(GL_RENDERER));
}              


/*Reshape*/
/* Crappy reshape handler for glut
 */
static void Reshape(int Width,int Height) {

  glViewport(0,0,Width,Height);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glFrustum(-1,1,-1,1,1.5,500);
  gluLookAt(0,0,400, 0,0,0, 0,1,0);
  glMatrixMode(GL_MODELVIEW);

  glutPostRedisplay();
}

/*Display*/
/* Crappy display handler
 */
static void Display() {
  int t,u;

  glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
  
  glLoadIdentity();
  glRotatef(Angle[0],1,0,0);
  glRotatef(Angle[1],0,1,0);
  glRotatef(Angle[2],0,0,1);

  for(t=0;t<3;t++) {
    for(u=0;t<3;t++) {
      Angle[t]+=sin(Step[t][u]);
    }
  }
  
  glCallList(DisplayList);
  glutSwapBuffers();
}

/*Idle*/
/* Crappy idle handler for glut
 */
static void Idle() {
  glutPostRedisplay();
}
