/* Math.c
 * $Format: " * Version $ProjectVersion$"$
 * Version 0.27
 * Michael McTernan, mm7323@Bris.ac.uk
 * 26/2/00
 * Formerly Trig.c
 */    

#include <math.h>
#include <stdlib.h>
#include "Constants.h"
#include "Math.h"

float MTH_SinTable[360*(int)MATH_TRIG_ACCURACY];
float MTH_Random[MATH_RND_ELEMENTS];
int   MTH_LastRandom=0;

/*MTH_Init*/
/* Create the lookup tables 
 */
void MTH_Init() {
  int t;

  for(t=0;t<MATH_RND_ELEMENTS;t++) 
    MTH_Random[t]=(float)rand()/RAND_MAX;

  for(t=0;t<360*MATH_TRIG_ACCURACY;t++) 
    MTH_SinTable[t]=(float)sin( ( (float)t/MATH_TRIG_ACCURACY ) *M_PI/180);

/*  For testing the accuracy of the table
  for(t=-360;t<360;t++) {
    if(fabs(MATH_Sin(t)-sin( (float)t * M_PI/180 ))>.01 )
     printf("%d: Table: %f != ln: %f\n",t,TRG_Sin(t),sin( (float)t * M_PI/180) );
  } 
*/

}


