/* Math.c
 * $Format: " * Version $ProjectVersion$"$
 * Version 0.27
 * Michael McTernan, mm7323@Bris.ac.uk
 * 26/2/00
 */    

#ifndef MATH_HEADER
#define MATH_HEADER

#include "Constants.h"

#ifdef WIN32
  #define M_PI 3.141592654
#endif 

void MTH_Init();

extern float MTH_SinTable[];
extern float MTH_Random[MATH_RND_ELEMENTS];
extern int   MTH_LastRandom;

/* Fake functions for speedy lookups :) */
/* NOTE: Fails if d<-360 */
#define MTH_Sin(d) MTH_SinTable[(int)((d+360)*MATH_TRIG_ACCURACY)%(int)(360*MATH_TRIG_ACCURACY)]
#define MTH_Cos(d) MTH_Sin( ((d)+90.0) )

#define MTH_Square(a)  ((a)*(a))
#define MTH_Rand()  MTH_Random[++MTH_LastRandom % MATH_RND_ELEMENTS]

#ifdef WIN32
  #define rint(a)   ((a) < 0) ? (int)((a) - 0.5) : (int) ((a) + 0.5);
#endif

#endif

