/* Vector.h
 * $Format: " * Version $ProjectVersion$"$
 * Version 0.27
 * Michael McTernan, mm7323@Bris.ac.uk
 * 23/11/99
 */

#ifndef VECTOR_TYPE_HEADER
#define VECTOR_TYPE_HEADER

#include <math.h>
#include "Math.h"

typedef float vec_t;      /* Change to GLfloat at a later date? */

typedef vec_t vec2_t[2];
typedef vec_t vec3_t[3];

#define VEC_Magnitude(v) sqrt(MTH_Square((v)[2])+MTH_Square((v)[0])+MTH_Square((v)[1]))
#define VEC_dotProduct(a,b)  (((a)[0]*(b)[0])+((a)[1]*(b)[1])+((a)[2]*(b)[2]))

/* Paul's function */
void VEC_Bounce(vec3_t *Result,vec3_t ApproachVector,vec3_t IntersectPoint,vec3_t PlaneNormal);
float VEC_Angle(vec3_t ApproachVector,int Plane);

#endif

